//+------------------------------------------------------------------+
//|                                                        BB-HL.mq5 |
//|                                Copyright  2005, David W. Thomas |
//|                                           mailto:davidwt@usa.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, David W. Thomas"
#property link      "mailto:davidwt@usa.net"
#property description ""
//---   
#property version   "1.00"
//---     
#property indicator_chart_window 
//---    3
#property indicator_buffers 3 
//---   5  
#property indicator_plots   3
//+-----------------------------------+
//|       |
//+-----------------------------------+
//---     
#property indicator_type1   DRAW_LINE
//---       DeepPink 
#property indicator_color1 clrDeepPink
//---   -  
#property indicator_style1  STYLE_SOLID
//---     1
#property indicator_width1  1
//---   
#property indicator_label1  "X2MA"
//+--------------------------------------------+
//|    BB   |
//+--------------------------------------------+
//---      
#property indicator_type2   DRAW_LINE
#property indicator_type3   DRAW_LINE
//---    
#property indicator_color2  clrDodgerBlue
#property indicator_color3  clrDodgerBlue
//---   -  
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
//---     1
#property indicator_width2  1
#property indicator_width3  1
//---    
#property indicator_label2  "+2Sigma"
#property indicator_label3  "-2Sigma"
//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//---    CXMA  CStdDeviation   SmoothAlgorithms.mqh
CXMA XMA1,XMA2;
CStdDeviation STD;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simple Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method MA_Method1=MODE_SMA;  //   
input uint Length1=100;                   //                        
input int Phase1=15;                      //   
//--- Phase1:  JJMA    -100 ... +100,     ;
//--- Phase1:  VIDIA   CMO,  AMA    
input Smooth_Method MA_Method2=MODE_JJMA; //   
input uint Length2=20;                    //     
input int Phase2=100;                     //   
//--- Phase2:  JJMA    -100 ... +100,     ;
//--- Phase2:  VIDIA   CMO,  AMA    
input uint BandsPeriod=100;               //   BB
input double BandsDeviation=2.0;          // - 
input Applied_price_ IPC=PRICE_CLOSE;     //  
input int Shift=0;                        //      
input int PriceShift=0;                   //      
//+-----------------------------------+
//---   ,   
//---      
double X2MA[];
//---   ,   
//---        
double ExtLineBuffer1[],ExtLineBuffer2[];
//---      
double dPriceShift;
//---      
int min_rates_total,min_rates_1,min_rates_2;
//---   
int Count[];
double Value[];
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+   
void Recount_ArrayZeroPos(int &CoArr[],//        
                          int Size)
  {
//---
   int numb,Max1,Max2;
   static int count=1;

   Max2=Size;
   Max1=Max2-1;

   count--;
   if(count<0) count=Max1;

   for(int iii=0; iii<Max2; iii++)
     {
      numb=iii+count;
      if(numb>Max1) numb-=Max2;
      CoArr[iii]=numb;
     }
//---
  }
//+------------------------------------------------------------------+   
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---     
   min_rates_1=XMA1.GetStartBars(MA_Method1,Length1,Phase1)+1;
   min_rates_2=min_rates_1+XMA2.GetStartBars(MA_Method2,Length2,Phase2);
   min_rates_total=min_rates_2+int(BandsPeriod);
//---       
   XMA1.XMALengthCheck("Length1",Length1);
   XMA2.XMALengthCheck("Length2",Length2);
   XMA2.XMALengthCheck("BandsPeriod",BandsPeriod);
//---       
   XMA1.XMAPhaseCheck("Phase1",Phase1,MA_Method1);
   XMA2.XMAPhaseCheck("Phase2",Phase2,MA_Method2);
//---    
   dPriceShift=_Point*PriceShift;
//---       
   ArrayResize(Count,BandsPeriod);
   ArrayResize(Value,BandsPeriod);
//---  
   ArrayInitialize(Count,0);
   ArrayInitialize(Value,0.0);
//---      
   SetIndexBuffer(0,X2MA,INDICATOR_DATA);
//---    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//---      
   SetIndexBuffer(1,ExtLineBuffer1,INDICATOR_DATA);
   SetIndexBuffer(2,ExtLineBuffer2,INDICATOR_DATA);
//---  ,      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//---      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      
   string shortname;
   string Smooth1=XMA1.GetString_MA_Method(MA_Method1);
   string Smooth2=XMA1.GetString_MA_Method(MA_Method2);
   StringConcatenate(shortname,"BB-HL(",Length1,", ",Length2,", ",BandsPeriod,", ",Smooth1,", ",Smooth2,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---  
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---       
   double price,x1xma,x2xma,Sum,diff1,diff2,res;
//---        
   int first,bar;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0;                   //      
   else first=prev_calculated-1; //      
//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //---   PriceSeries     price_
      price=PriceSeries(IPC,bar,open,low,high,close);
      //---    XMASeries 
      x1xma=XMA1.XMASeries(0,prev_calculated,rates_total,MA_Method1,Phase1,Length1,price,bar,false);
      x2xma=XMA2.XMASeries(min_rates_1,prev_calculated,rates_total,MA_Method2,Phase2,Length2,x1xma,bar,false);
      //---       
      X2MA[bar]=x2xma+dPriceShift;   
      diff1=high[bar]-x2xma;
      diff1*=diff1;
      diff2=low[bar]-x2xma;
      diff2*=diff2;
      Value[Count[0]]=MathMax(diff1,diff2);      
      Sum=0;
      for(int iii=0; iii<int(BandsPeriod); iii++) Sum+=Value[iii];
      res=Sum/BandsPeriod;
      res=BandsDeviation*MathSqrt(res);
      ExtLineBuffer1[bar]=x2xma+res+dPriceShift;
      ExtLineBuffer2[bar]=x2xma-res+dPriceShift;
      if(bar<rates_total-1) Recount_ArrayZeroPos(Count,BandsPeriod);
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
